import _JSON$stringify from '@babel/runtime-corejs2/core-js/json/stringify';
import _objectWithoutProperties from '@babel/runtime-corejs2/helpers/esm/objectWithoutProperties';
import { createElement, Fragment, Component, Children } from 'react';
import { FormikConsumer, Formik, Field, Form, ErrorMessage, FieldArray, FastField } from 'formik';
import _Object$keys from '@babel/runtime-corejs2/core-js/object/keys';
import _Promise from '@babel/runtime-corejs2/core-js/promise';
import { object, string } from 'yup';
import _extends from '@babel/runtime-corejs2/helpers/esm/extends';
import _classCallCheck from '@babel/runtime-corejs2/helpers/esm/classCallCheck';
import _createClass from '@babel/runtime-corejs2/helpers/esm/createClass';
import _possibleConstructorReturn from '@babel/runtime-corejs2/helpers/esm/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime-corejs2/helpers/esm/getPrototypeOf';
import _inherits from '@babel/runtime-corejs2/helpers/esm/inherits';
import _assertThisInitialized from '@babel/runtime-corejs2/helpers/esm/assertThisInitialized';
import _defineProperty from '@babel/runtime-corejs2/helpers/esm/defineProperty';

var Debug = function Debug() {
  return createElement("div", {
    style: {
      margin: '3rem 0',
      borderRadius: 4,
      background: '#f6f8fa',
      boxShadow: '0 0 1px  #eee inset'
    }
  }, createElement("div", {
    style: {
      textTransform: 'uppercase',
      fontSize: 11,
      borderTopLeftRadius: 4,
      borderTopRightRadius: 4,
      fontWeight: 500,
      padding: '.5rem',
      background: '#555',
      color: '#fff',
      letterSpacing: '1px'
    }
  }, "Formik State"), createElement(FormikConsumer, null, function (_ref) {
    var validationSchema = _ref.validationSchema,
        validate = _ref.validate,
        rest = _objectWithoutProperties(_ref, ["validationSchema", "validate"]);

    return createElement("pre", {
      style: {
        fontSize: '.65rem',
        padding: '.25rem .5rem',
        overflowX: 'scroll'
      }
    }, _JSON$stringify(rest, null, 2));
  }));
};

var initialValues = {
  friends: [{
    name: '',
    email: ''
  }]
};

var SignIn = function SignIn() {
  return createElement("div", null, createElement("h1", null, "Invite friends"), createElement(Formik, {
    initialValues: initialValues,
    onSubmit: function onSubmit(values) {
      setTimeout(function () {
        alert(_JSON$stringify(values, null, 2));
      }, 500);
    },
    render: function render(_ref) {
      var values = _ref.values;
      return createElement(Form, null, createElement(FieldArray, {
        name: "friends",
        render: function render(_ref2) {
          var remove = _ref2.remove,
              push = _ref2.push;
          return createElement("div", null, values.friends.length > 0 && values.friends.map(function (index) {
            return createElement("div", {
              className: "row",
              key: String(index)
            }, createElement("div", {
              className: "col"
            }, createElement("label", {
              htmlFor: "friends.".concat(index, ".name")
            }, "Name"), createElement(Field, {
              name: "friends.".concat(index, ".name"),
              placeholder: "Jane Doe",
              type: "text"
            }), createElement(ErrorMessage, {
              name: "friends.".concat(index, ".name"),
              component: "div",
              className: "field-error"
            })), createElement("div", {
              className: "col"
            }, createElement("label", {
              htmlFor: "friends.".concat(index, ".email")
            }, "Email"), createElement(Field, {
              name: "friends.".concat(index, ".email"),
              placeholder: "jane@acme.com",
              type: "email"
            }), createElement(ErrorMessage, {
              name: "friends.".concat(index, ".name"),
              component: "div",
              className: "field-error"
            })), createElement("div", {
              className: "col"
            }, createElement("button", {
              type: "button",
              className: "secondary",
              onClick: function onClick() {
                return remove(Number(index));
              }
            }, "X")));
          }), createElement("button", {
            type: "button",
            className: "secondary",
            onClick: function onClick() {
              return push({
                name: '',
                email: ''
              });
            }
          }, "Add Friend"));
        }
      }), createElement("button", {
        type: "submit"
      }, "Invite"), createElement(Debug, null));
    }
  }));
};

var sleep = function sleep(ms) {
  return new _Promise(function (resolve) {
    return setTimeout(resolve, ms);
  });
};

var validate = function validate(values) {
  return sleep(300).then(function () {
    var errors = {};

    if (['admin', 'null', 'god'].includes(values.username)) {
      errors.username = 'Nice try';
    }

    if (!values.username) {
      errors.username = 'Required';
    }

    if (_Object$keys(errors).length) {
      throw errors;
    }
  });
};

var Username = function Username() {
  return createElement("div", null, createElement("h1", null, "Pick a username"), createElement(Formik, {
    initialValues: {
      username: ''
    },
    validate: validate,
    onSubmit: function onSubmit(values) {
      sleep(500).then(function () {
        alert(_JSON$stringify(values, null, 2));
      });
    },
    render: function render() {
      return createElement(Form, null, createElement("label", {
        htmlFor: "username"
      }, "Username"), createElement(Field, {
        name: "username",
        type: "text"
      }), createElement(ErrorMessage, {
        name: "username"
      }), createElement("button", {
        type: "submit"
      }, "Submit"), createElement(Debug, null));
    }
  }));
};

var Basic = function Basic() {
  return createElement("div", null, createElement("h1", null, "Sign Up"), createElement(Formik, {
    initialValues: {
      firstName: '',
      lastName: '',
      email: ''
    },
    onSubmit: function onSubmit(values) {
      setTimeout(function () {
        alert(_JSON$stringify(values, null, 2));
      }, 500);
    },
    render: function render() {
      return createElement(Form, null, createElement("label", {
        htmlFor: "firstName"
      }, "First Name"), createElement(Field, {
        name: "firstName",
        placeholder: "Jane"
      }), createElement("label", {
        htmlFor: "lastName"
      }, "Last Name"), createElement(Field, {
        name: "lastName",
        placeholder: "Doe"
      }), createElement("label", {
        htmlFor: "email"
      }, "Email"), createElement(Field, {
        name: "email",
        placeholder: "jane@acme.com",
        type: "email"
      }), createElement("button", {
        type: "submit"
      }, "Submit"), createElement(Debug, null));
    }
  }));
};

var BasicTS = function BasicTS() {
  return createElement("div", null, createElement("h1", null, "Signup"), createElement(Formik, {
    initialValues: {
      firstName: '',
      lastName: '',
      email: ''
    },
    onSubmit: function onSubmit(values, _ref) {
      var setSubmitting = _ref.setSubmitting;
      setTimeout(function () {
        alert(_JSON$stringify(values, null, 2));
        setSubmitting(false);
      }, 500);
    },
    render: function render() {
      return createElement(Form, null, createElement("label", {
        htmlFor: "firstName"
      }, "First Name"), createElement(Field, {
        id: "firstName",
        name: "firstName",
        placeholder: "John"
      }), createElement("label", {
        htmlFor: "lastName"
      }, "Last Name"), createElement(Field, {
        id: "lastName",
        name: "lastName",
        placeholder: "Doe"
      }), createElement("label", {
        htmlFor: "email"
      }, "Email"), createElement(Field, {
        id: "email",
        name: "email",
        placeholder: "john@acme.com",
        type: "email"
      }), createElement("button", {
        type: "submit"
      }, "Submit"));
    }
  }));
};

var Schema =
/*#__PURE__*/
object().shape({
  email:
  /*#__PURE__*/
  string().required('This field is required')
}); // Async Validation

var sleep$1 = function sleep(ms) {
  return new _Promise(function (resolve) {
    return setTimeout(resolve, ms);
  });
};

var validate$1 = function validate() {
  return sleep$1(300).then(function () {
    throw {
      zip: 'This field is required'
    };
  });
};

var isRequired = function isRequired(message) {
  return function (value) {
    return Boolean(value) ? undefined : message;
  };
};

var FieldLevelValidation = function FieldLevelValidation() {
  return createElement("div", null, createElement("h1", null, "Pick a username"), createElement(Formik, {
    validationSchema: Schema,
    validate: validate$1,
    initialValues: {
      username: '',
      email: '',
      zip: ''
    },
    onSubmit: function onSubmit(values) {
      sleep$1(500).then(function () {
        alert(_JSON$stringify(values, null, 2));
      });
    },
    render: function render() {
      return createElement(Form, null, createElement("label", {
        htmlFor: "username"
      }, "Username"), createElement("div", null, createElement(Field, {
        name: "username",
        validate: isRequired('This field is required'),
        type: "text",
        placeholder: "username"
      }), createElement(ErrorMessage, {
        name: "username"
      })), createElement("br", null), createElement("div", null, createElement(Field, {
        name: "email",
        validate: isRequired('This field is required'),
        type: "text",
        placeholder: "email"
      }), createElement(ErrorMessage, {
        name: "email"
      })), createElement("br", null), createElement("div", null, createElement(Field, {
        name: "zip",
        validate: isRequired('This field is required'),
        type: "text",
        placeholder: "zip"
      }), createElement(ErrorMessage, {
        name: "zip"
      })), createElement("br", null), createElement("button", {
        type: "submit"
      }, "Submit"), createElement(Debug, null));
    }
  }));
};

// we can abstract a generic "Fieldset" component for most of our inputs.

var Fieldset = function Fieldset(_ref) {
  var name = _ref.name,
      label = _ref.label,
      rest = _objectWithoutProperties(_ref, ["name", "label"]);

  return createElement(Fragment, null, createElement("label", {
    htmlFor: name
  }, label), createElement(Field, _extends({
    id: name,
    name: name
  }, rest)), createElement(ErrorMessage, {
    name: name
  }));
};

var SignUp = function SignUp() {
  return createElement("div", null, createElement("h1", null, "Sign Up"), createElement(Formik, {
    initialValues: {
      email: '',
      color: '',
      animal: '',
      website: ''
    },
    validationSchema: object().shape({
      email: string().email('Invalid email address').required('Required'),
      color: string().required('Required'),
      website: string().url('Invalid URL').required('Required'),
      animal: string().required('Required')
    }),
    onSubmit: function onSubmit(values) {
      setTimeout(function () {
        alert(_JSON$stringify(values, null, 2));
      }, 500);
    },
    render: function render(_ref2) {
      var isSubmitting = _ref2.isSubmitting,
          handleReset = _ref2.handleReset;
      return createElement(Form, null, createElement(Fieldset, {
        name: "email",
        type: "email",
        label: "Email",
        placeholder: "jane@acme.com"
      }), createElement(Fieldset, {
        name: "color",
        label: "Favorite Color",
        component: "select"
      }, createElement("option", {
        value: ""
      }, "Select a Color"), createElement("option", {
        value: "red"
      }, "Red"), createElement("option", {
        value: "green"
      }, "Green"), createElement("option", {
        value: "blue"
      }, "Blue")), createElement(Fieldset, {
        name: "website",
        type: "url",
        label: "Website",
        placeholder: "https://example.com"
      }), createElement(Fieldset, {
        name: "animal",
        component: "select",
        label: "Favorite Animal"
      }, createElement("option", {
        value: ""
      }, "Select an animal"), createElement("option", {
        value: "tiger"
      }, "Tiger"), createElement("option", {
        value: "bear"
      }, "Bear"), createElement("option", {
        value: "shark"
      }, "Shark")), createElement("button", {
        type: "reset",
        className: "secondary",
        disabled: isSubmitting,
        onClick: handleReset
      }, "Reset"), createElement("button", {
        type: "submit"
      }, "Submit"), createElement(Debug, null));
    }
  }));
};

// comes with special support for Yup by @jquense. It has a builder API like
// React PropTypes / Hapi.js's Joi. You can define these inline or, you may want
// to keep them separate so you can reuse schemas (e.g. address) across your application.

var SignUpSchema =
/*#__PURE__*/
object().shape({
  email:
  /*#__PURE__*/
  string().email('Invalid email address').required('Required'),
  firstName:
  /*#__PURE__*/
  string().min(2, 'Must be longer than 2 characters').max(20, 'Nice try, nobody has a first name that long').required('Required'),
  lastName:
  /*#__PURE__*/
  string().min(2, 'Must be longer than 2 characters').max(20, 'Nice try, nobody has a last name that long').required('Required')
}); // <ErrorMessage /> will ONLY render when a field has an error and has been touched.

var SignUp$1 = function SignUp() {
  return createElement("div", null, createElement("h1", null, "Sign up"), createElement(Formik, {
    initialValues: {
      email: '',
      firstName: '',
      lastName: ''
    },
    validationSchema: SignUpSchema,
    onSubmit: function onSubmit(values) {
      setTimeout(function () {
        alert(_JSON$stringify(values, null, 2));
      }, 500);
    },
    render: function render() {
      return createElement(Form, null, createElement("label", {
        htmlFor: "firstName"
      }, "First Name"), createElement(Field, {
        name: "firstName",
        placeholder: "Jane",
        type: "text"
      }), createElement(ErrorMessage, {
        name: "firstName",
        component: "div",
        className: "field-error"
      }), createElement("label", {
        htmlFor: "lastName"
      }, "Last Name"), createElement(Field, {
        name: "lastName",
        placeholder: "Doe",
        type: "text"
      }), createElement(ErrorMessage, {
        name: "firstName"
      }, function (msg
      /** this is the same as the above */
      ) {
        return createElement("div", {
          className: "field-error"
        }, msg);
      }), createElement("label", {
        htmlFor: "email"
      }, "Email"), createElement(Field, {
        name: "email",
        placeholder: "jane@acme.com",
        type: "email"
      }), createElement(ErrorMessage, {
        name: "email",
        className: "field-error"
      }), createElement("button", {
        type: "submit"
      }, "Submit"), createElement(Debug, null));
    }
  }));
};

var Input =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Input, _React$Component);

  function Input() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Input);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Input)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renders", 0);

    return _this;
  }

  _createClass(Input, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          field = _this$props.field,
          form = _this$props.form,
          rest = _objectWithoutProperties(_this$props, ["field", "form"]);

      return createElement("div", null, createElement("input", _extends({}, field, rest)), createElement("p", null, "# of renders: ", this.renders++));
    }
  }]);

  return Input;
}(Component);

var Basic$1 = function Basic() {
  return createElement("div", null, createElement("h1", null, "Sign Up"), createElement(Formik, {
    initialValues: {
      firstName: '',
      lastName: '',
      email: ''
    },
    onSubmit: function onSubmit(values, _ref) {
      var setSubmitting = _ref.setSubmitting;
      setTimeout(function () {
        setSubmitting(false);
        alert(_JSON$stringify(values, null, 2));
      }, 500);
    },
    render: function render(_ref2) {
      var isSubmitting = _ref2.isSubmitting;
      return createElement(Form, null, createElement("label", {
        htmlFor: "firstName"
      }, "First Name"), createElement(FastField, {
        name: "firstName",
        placeholder: "Jane",
        component: Input,
        disabled: isSubmitting
      }), createElement("label", {
        htmlFor: "lastName"
      }, "Last Name"), createElement(FastField, {
        name: "lastName",
        placeholder: "Doe",
        component: Input,
        disabled: isSubmitting
      }), createElement("label", {
        htmlFor: "email"
      }, "Email"), createElement(FastField, {
        name: "email",
        placeholder: "jane@acme.com",
        type: "email",
        component: Input,
        disabled: isSubmitting
      }), createElement("button", {
        type: "submit"
      }, "Submit"), createElement(Debug, null));
    }
  }));
};

var isRequired$1 = function isRequired(message) {
  return function (value) {
    return !!value ? undefined : message;
  };
};

var FieldLevelValidation$1 = function FieldLevelValidation() {
  return createElement("div", null, createElement("h1", null, "Pick a username"), createElement(Formik, {
    initialValues: {
      username: '',
      email: ''
    },
    onSubmit: function onSubmit(values) {
      alert(_JSON$stringify(values, null, 2));
    },
    render: function render(_ref) {
      var setFieldValue = _ref.setFieldValue,
          setFieldTouched = _ref.setFieldTouched,
          validateField = _ref.validateField,
          validateForm = _ref.validateForm;
      return createElement(Form, null, createElement("label", {
        htmlFor: "username"
      }, "Username"), createElement("div", null, createElement(Field, {
        name: "username",
        validate: isRequired$1('This field is required'),
        type: "text",
        placeholder: "Username"
      }), createElement(ErrorMessage, {
        name: "username"
      })), createElement("br", null), createElement("div", null, createElement(Field, {
        name: "email",
        validate: isRequired$1('This field is required'),
        type: "text",
        placeholder: "Email"
      }), createElement(ErrorMessage, {
        name: "email"
      })), createElement("div", null, createElement("div", null, "username field actions"), createElement("button", {
        type: "button",
        onClick: function onClick() {
          setFieldTouched('username', true, true);
        }
      }, "setFieldTouched"), createElement("button", {
        type: "button",
        onClick: function onClick() {
          setFieldValue('username', '', true);
        }
      }, "setFieldValue"), createElement("button", {
        type: "button",
        onClick: function onClick() {
          validateField('username');
        }
      }, "validateField"), createElement("br", null)), createElement("br", null), createElement("div", null, createElement("div", null, "Form actions"), createElement("button", {
        type: "button",
        onClick: validateForm
      }, "validate form"), createElement("button", {
        type: "submit"
      }, "Submit")), createElement(Debug, null));
    }
  }));
};

var sleep$2 = function sleep(ms) {
  return new _Promise(function (resolve) {
    return setTimeout(resolve, ms);
  });
};

var required = function required(value) {
  return value ? undefined : 'Required';
};

var Wizard =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Wizard, _React$Component);

  function Wizard(props) {
    var _this;

    _classCallCheck(this, Wizard);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Wizard).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "next", function (values) {
      return _this.setState(function (state) {
        return {
          page: Math.min(state.page + 1, Array(_this.props.children).length - 1),
          values: values
        };
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "previous", function () {
      return _this.setState(function (state) {
        return {
          page: Math.max(state.page - 1, 0)
        };
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "validate", function (values) {
      var activePage = Children.toArray(_this.props.children)[_this.state.page];

      return activePage.props.validate ? activePage.props.validate(values) : {};
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleSubmit", function (values, bag) {
      var _this$props = _this.props,
          children = _this$props.children,
          onSubmit = _this$props.onSubmit;
      var page = _this.state.page;
      var isLastPage = page === Children.count(children) - 1;

      if (isLastPage) {
        return onSubmit(values, bag);
      } else {
        _this.next(values);

        bag.setTouched({});
        bag.setSubmitting(false);
      }
    });

    _this.state = {
      page: 0,
      values: props.initialValues
    };
    return _this;
  }

  _createClass(Wizard, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var children = this.props.children;
      var _this$state = this.state,
          page = _this$state.page,
          values = _this$state.values;
      var activePage = Children.toArray(children)[page];
      var isLastPage = page === Children.count(children) - 1;
      return createElement(Formik, {
        initialValues: values,
        enableReinitialize: false,
        validate: this.validate,
        onSubmit: this.handleSubmit,
        render: function render(_ref) {
          var handleSubmit = _ref.handleSubmit,
              isSubmitting = _ref.isSubmitting;
          return createElement("form", {
            onSubmit: handleSubmit
          }, activePage, createElement("div", {
            className: "buttons"
          }, page > 0 && createElement("button", {
            type: "button",
            className: "secondary",
            onClick: _this2.previous
          }, "\xAB Previous"), !isLastPage && createElement("button", {
            type: "submit"
          }, "Next \xBB"), isLastPage && createElement("button", {
            type: "submit",
            disabled: isSubmitting
          }, "Submit")), createElement(Debug, null));
        }
      });
    }
  }]);

  return Wizard;
}(Component);

_defineProperty(Wizard, "Page", function (_ref2) {
  var children = _ref2.children;
  return children;
});

var App = function App() {
  return createElement("div", {
    className: "App"
  }, createElement("h1", null, "Multistep / Form Wizard "), createElement(Wizard, {
    initialValues: {
      firstName: '',
      lastName: '',
      email: '',
      favoriteColor: ''
    },
    onSubmit: function onSubmit(values, actions) {
      sleep$2(300).then(function () {
        window.alert(_JSON$stringify(values, null, 2));
        actions.setSubmitting(false);
      });
    }
  }, createElement(Wizard.Page, null, createElement("div", null, createElement("label", null, "First Name"), createElement(Field, {
    name: "firstName",
    component: "input",
    type: "text",
    placeholder: "First Name",
    validate: required
  }), createElement(ErrorMessage, {
    name: "firstName",
    component: "div",
    className: "field-error"
  })), createElement("div", null, createElement("label", null, "Last Name"), createElement(Field, {
    name: "lastName",
    component: "input",
    type: "text",
    placeholder: "Last Name",
    validate: required
  }), createElement(ErrorMessage, {
    name: "lastName",
    component: "div",
    className: "field-error"
  }))), createElement(Wizard.Page, {
    validate: function validate(values) {
      var errors = {};

      if (!values.email) {
        errors.email = 'Required';
      }

      if (!values.favoriteColor) {
        errors.favoriteColor = 'Required';
      }

      return errors;
    }
  }, createElement("div", null, createElement("label", null, "Email"), createElement(Field, {
    name: "email",
    component: "input",
    type: "email",
    placeholder: "Email"
  }), createElement(ErrorMessage, {
    name: "email",
    component: "div",
    className: "field-error"
  })), createElement("div", null, createElement("label", null, "Favorite Color"), createElement(Field, {
    name: "favoriteColor",
    component: "select"
  }, createElement("option", {
    value: ""
  }, "Select a Color"), createElement("option", {
    value: "#ff0000"
  }, "\u2764\uFE0F Red"), createElement("option", {
    value: "#00ff00"
  }, "\uD83D\uDC9A Green"), createElement("option", {
    value: "#0000ff"
  }, "\uD83D\uDC99 Blue")), createElement(ErrorMessage, {
    name: "favoriteColor",
    component: "div",
    className: "field-error"
  })))));
};

// comes with special support for Yup by @jquense. It has a builder API like
// React PropTypes / Hapi.js's Joi. You can define these inline or, you may want
// to keep them separate so you can reuse schemas (e.g. address) across your application.

var SignUpSchema$1 =
/*#__PURE__*/
object().shape({
  email:
  /*#__PURE__*/
  string().email('Invalid email address').required('Required'),
  firstName:
  /*#__PURE__*/
  string().min(2, 'Must be longer than 2 characters').max(20, 'Nice try, nobody has a first name that long').required('Required'),
  lastName:
  /*#__PURE__*/
  string().min(2, 'Must be longer than 2 characters').max(20, 'Nice try, nobody has a last name that long').required('Required')
});

var SignUp$2 = function SignUp() {
  return createElement("div", null, createElement("h1", null, "Sign up"), createElement(Formik, {
    initialValues: {
      email: '',
      firstName: '',
      lastName: ''
    },
    validationSchema: SignUpSchema$1,
    onSubmit: function onSubmit(values) {
      setTimeout(function () {
        alert(_JSON$stringify(values, null, 2));
      }, 500);
    },
    render: function render() {
      return createElement(Form, null, createElement("label", {
        htmlFor: "firstName"
      }, "First Name"), createElement(Field, {
        name: "firstName",
        placeholder: "Jane",
        type: "text"
      }), createElement(ErrorMessage, {
        name: "firstName",
        component: "div",
        className: "field-error"
      }), createElement("label", {
        htmlFor: "lastName"
      }, "Last Name"), createElement(Field, {
        name: "lastName",
        placeholder: "Doe",
        type: "text"
      }), createElement(ErrorMessage, {
        name: "lastName",
        component: "div",
        className: "field-error"
      }), createElement("label", {
        htmlFor: "email"
      }, "Email"), createElement(Field, {
        name: "email",
        placeholder: "jane@acme.com",
        type: "email"
      }), createElement(ErrorMessage, {
        name: "email",
        component: "div",
        className: "field-error"
      }), createElement("button", {
        type: "submit"
      }, "Submit"), createElement(Debug, null));
    }
  }));
};

var validate$2 = function validate(values) {
  var errors = {};

  if (!values.email) {
    errors.email = 'Required';
  } else if (!/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i.test(values.email)) {
    errors.email = 'Invalid email address';
  }

  return errors;
};

var SignIn$1 = function SignIn() {
  return createElement("div", null, createElement("h1", null, "Sign In"), createElement(Formik, {
    initialValues: {
      email: '',
      password: ''
    },
    validate: validate$2,
    onSubmit: function onSubmit(values) {
      setTimeout(function () {
        alert(_JSON$stringify(values, null, 2));
      }, 500);
    },
    render: function render() {
      return createElement(Form, null, createElement("label", {
        htmlFor: "email"
      }, "Email"), createElement(Field, {
        name: "email",
        placeholder: "john@acme.com",
        type: "email"
      }), createElement("div", {
        className: "field-error"
      }, createElement(ErrorMessage, {
        name: "email"
      })), createElement("label", {
        htmlFor: "password"
      }, "Password"), createElement(Field, {
        name: "password",
        type: "password"
      }), createElement("button", {
        type: "submit"
      }, "Sign In"), createElement(Debug, null));
    }
  }));
};

/* export { default as withFormik } from './withFormik';
export { default as withFF } from './withFF';
 */

export { SignIn as Arrays, Username as AsyncValidation, Basic, BasicTS, FieldLevelValidation as CombinedValidations, SignUp as CustomInputs, Debug, SignUp$1 as ErrorMessage, Basic$1 as FastField, FieldLevelValidation$1 as FieldLevelValidation, App as MultistepWizard, SignUp$2 as SchemaValidation, SignIn$1 as SyncValidation };
//# sourceMappingURL=ff-examples.esm.js.map
